/* $Header: /ext/yav/catty/xpx/RCS/colset.c,v 1.8 1994/01/17 22:19:08 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"

#define BDW 1
#define COLSETW 64
#define COLSETH 18
#define COLBOXW 16		/* < COLSETW */

create_colset_window(x, y)
{
  int i;

  for (i = 0; i < MAXCOLSET; i++) {
    colwin[i] = XCreateSimpleWindow(dsp, win, x, y, COLSETW, COLSETH,
				    BDW, fg, bg);
    colgc[i] = XCreateGC(dsp, colwin[i], 0, 0);
    XSelectInput(dsp, colwin[i],
		 ButtonPressMask|ExposureMask|EnterWindowMask|LeaveWindowMask);
    XMapRaised(dsp, colwin[i]);
    y += COLSETH+BDW;
  }
  return 0;
}

close_colset_window()
{
  int i;
  
  for (i = 0; i < MAXCOLSET; i++)
    XDestroyWindow(dsp, colwin[i]);
}

redraw_col(n)
{
  int len, w, ww;
  char buf[256];
  GC g;
  COL *cp;

  cp = color_buf+current_pal*MAXCOLSET+n;
  sprintf(buf, "%x:%x%x%x", n, cp->green>>4, cp->red>>4, cp->blue>>4);
  len = strlen(buf);
  ww = COLSETW-COLBOXW;
  XFillRectangle(dsp, colwin[n], colgc[n], 0, 0, COLBOXW, COLSETH);
  if (n == current_col) {
    w = XTextWidth(fs1, buf, len);
    XFillRectangle(dsp, colwin[n], gc0, COLBOXW, 0, ww, COLSETH);
    g = gc1;
  } else {
    w = XTextWidth(fs0, buf, len);
    g = gc0;
  }
  XDrawString(dsp, colwin[n], g, COLBOXW+(ww-w)/2, COLSETH-5, buf, len);
}

highlight_col(n)
{
  menuwin_highlight(colwin[n], n == current_col);
}

colset_expose(ev)
     XEvent *ev;
{
  int i;
  
  if (ev->xexpose.count == 0) {
    for (i = 0; i < MAXCOLSET; i++) {
      if (ev->xexpose.window == colwin[i]) {
	redraw_col(i);
      }
    }
  }
}

colset_button(ev)
     XEvent *ev;
{
  int i, oldcol;

  for (i = 0; i < MAXCOLSET; i++) {
    if (ev->xbutton.window == colwin[i]) {
      switch(ev->xbutton.button) {
      case 1:
	if (i != current_col) {
	  oldcol = current_col;
	  current_col = i;
	  if (oldcol >= 0)
	    XClearArea(dsp, colwin[oldcol], 0, 0, 0, 0, True);
	  if (current_col >= 0)
	    XClearArea(dsp, colwin[current_col], 0, 0, 0, 0, True);
	}
      }
    }
  }
}

colset_enter(ev)
     XEvent *ev;
{
  int i;

  for (i = 0; i < MAXCOLSET; i++) {
    if (ev->xcrossing.window == colwin[i])
      highlight_col(i);
  }
}

/* End of file */
