/* $Header: /ext/yav/catty/xpx/RCS/grid.c,v 1.4 1994/02/02 07:13:54 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"
#include "griddef.h"

#define BDW 1
#define GRIDN 3
#define GRIDW 24
#define GRIDH 16
#define MAXGRID 32

char *grid_strfunc(p)
     MENU *p;
{
  sprintf(p->str, "%d", grid_size);
  return p->str;
}

static MENU gridmenu[] = {
  {
    GRID_OUT,
    0, 0, GRIDW, GRIDH,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    0, 0, BDW,
    NULL, "<"},
  {
    GRID_NUM,
    GRIDW+BDW, 0, GRIDW, GRIDH,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    0, 0, BDW,
    grid_strfunc, "1"},
  {
    GRID_IN,
    (GRIDW+BDW)*2, 0, GRIDW, GRIDH,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    0, 0, BDW,
    NULL, ">"},
  {
    -1,
    0, 0, 0, 0,
    0, 0, 0,
    0, 0, 0,
    NULL, ""}};

create_grid_window(x, y)
{
  menuwin_create(gridmenu, win, x, y);
}

close_grid_window()
{
  menuwin_destroy(gridmenu);
}

grid_expose(ev)
     XEvent *ev;
{
  menuwin_expose(gridmenu, ev);
}

grid_in()
{
  if (grid_size < MAXGRID) {
    ++grid_size;
    XClearArea(dsp, gridmenu[GRID_NUM].win, 0, 0, 0, 0, True);
    gridmenu[GRID_IN].mode |= MenuModeMaskOn;
    menuwin_expose_sub(&gridmenu[GRID_IN]);
    if (grid_mode)
      img_expose(0, 0, imgwinwidth, imgwinheight);
    gridmenu[GRID_IN].mode &= ~MenuModeMaskOn;
    menuwin_expose_sub(&gridmenu[GRID_IN]);
  }
}

grid_out()
{
  if (grid_size > 1) {
    --grid_size;
    XClearArea(dsp, gridmenu[GRID_NUM].win, 0, 0, 0, 0, True);
    gridmenu[GRID_OUT].mode |= MenuModeMaskOn;
    menuwin_expose_sub(&gridmenu[GRID_OUT]);
    if (grid_mode)
      img_expose(0, 0, imgwinwidth, imgwinheight);
    gridmenu[GRID_OUT].mode &= ~MenuModeMaskOn;
    menuwin_expose_sub(&gridmenu[GRID_OUT]);
  }
}

grid_press(ev)
     XEvent *ev;
{
  int i;

  i = menuwin_press(gridmenu, ev);
  if (i < 0)
    return;
  switch(i) {
  case GRID_OUT:
    grid_out();
    break;
  case GRID_NUM:
    grid_mode = gridmenu[i].mode & MenuModeMaskOn;
    img_expose(0, 0, imgwinwidth, imgwinheight);
    break;
  case GRID_IN:
    grid_in();
    break;
  }
  XClearArea(dsp, gridmenu[i].win, 0, 0, 0, 0, True);
}

grid_enter(ev)
     XEvent *ev;
{
  menuwin_enter(gridmenu, ev);
}

grid_leave(ev)
     XEvent *ev;
{
  if (menuwin_leave(gridmenu, ev) >= 0)
    return 1;
  return 0;
}

/* End of file */
