/* $Header: /ext/yav/catty/xpx/RCS/main.c,v 1.27 1994/02/02 08:20:22 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "menudef.h"
#include "editdef.h"
#include "cursdef.h"

#define IMGSCRLW 16

#define COLSETX (PALSETX+32)
#define COLSETY PALSETY

#define IMGWINWIDTHMAX 640
#define IMGWINHEIGHTMAX 800

#define INTERNAL_ICONPIXMAP 1

/* #define DEFAULT_FONT "8x13" */
/* #define DEFAULT_BOLD_FONT "8x13bold" */
#define DEFAULT_FONT "-adobe-helvetica-medium-r-normal--*-120-*"
#define DEFAULT_BOLD_FONT "-adobe-helvetica-bold-r-normal--*-120-*"

extern MENU cursmenu[];

char rcsrev[] = "$Revision: 1.27 $";
char *myname = "xpx";
Display *dsp;
int scr;
Window win;
unsigned long fg, bg;
GC gc0, gc1, gridgc, areagc;
XImage *img;
Window imgwin;
XFontStruct *fs0, *fs1;
Window colwin[MAXCOLSET];
GC colgc[MAXCOLSET];
Window viewwin;
int view_sw = 0;
XImage *vimg = NULL;
int imgmaxw = 400;
int imgmaxh = 400;
int maxzoom = 6;
int current_col = -1;
int current_pal = 0;
int sw_quit = 0;
int double_clicked = 0;
int zoomfactor = 2;
char imgfilename[MAXPATHLEN] = "*Noname*";
char colfilename[MAXPATHLEN] = "*Noname*";
unsigned char *imgdata;
int imgofsx = 0;
int imgofsy = 0;
int imgwinwidth, imgwinheight;
int alloced_color = 0;
int alloced_common_color = 0;
int grid_mode = 0;
int grid_size = 8;
int imgfilew = 0;
int imgfileh = 0;
int curx = 0;
int cury = 0;
int curz = 0;
int scroll_stop = 1;
int scroll_speed = 8;
int edit_mode = EDIT_PLOT;
static struct {
  int x;
  int y;
} copypos0, copypos1, copyposd0, copyposd1,
  copysrc,
  lastcopypos0={0,0}, lastcopypos1 = {0,0};

COL color_buf[MAXPALSET*MAXCOLSET];
char coltbl[MAXPALSET*MAXCOLSET];
unsigned long pixtbl[MAXPALSET*MAXCOLSET];

static char *str_display = "";
static char *str_geometry = "";
static char *str_background = "Wheat";
static char *str_foreground = "Black";
static char *str_font = NULL;
static char *str_fontbold = NULL;
static Window scrlwin[4];
static int imgwin_noexpose = 1;
static int scrl_dir = 0;
static int copy_mode = 0;
static int use_private_color = 1;
static char grid_dash_list[2] = {1,1};
static Pixmap icon_pixmap = None;
#ifdef INTERNAL_ICONPIXMAP
#include "icon.xbm"
#endif

usage()
{
  fprintf(stderr, "* %s %s *\n", myname, rcsrev);
  fprintf(stderr, "written by yav (HBA00622@niftyserve.or.jp UHD98984@pcvan.or.jp)\n");
  fprintf(stderr, "usage : %s [options] col.kcf rei.cel\n", myname);
  exit(1);
}

char *filename(name)
     char *name;
{
  char *p;
  extern char *strrchr();

  if (name[0] == '\0')
    return "*Noname*";
  p = strrchr(name, '/');
  if (p != NULL)
    name = p+1;
  return name;
}

char *basefilename(name)
     char *name;
{
  char *p;
  extern char *strrchr();

  name = filename(name);
  p = strrchr(name, '.');
  if (p != NULL)
    *p = '\0';
  return name;
}


#define col8to32(x) (((x)<<24)|((x)<<16)|((x)<<8)|(x))
get_color_sub(i, p)
     COL *p;
{
  XColor col;
  unsigned long plane_masks[1];
  
  col.red = col8to32(p->red);
  col.green = col8to32(p->green);
  col.blue = col8to32(p->blue);
  col.flags = DoRed|DoGreen|DoBlue;
  if (coltbl[i] & CM_PRIVATE) {
    col.pixel = pixtbl[i];
    XStoreColor(dsp, DefaultColormap(dsp, scr), &col);
  } else {
    if (use_private_color &&
	XAllocColorCells(dsp, DefaultColormap(dsp, scr), False,
			 plane_masks, 0, &col.pixel, 1)) {
      XStoreColor(dsp, DefaultColormap(dsp, scr), &col);
      coltbl[i] = CM_ALLOCED | CM_UPDATING | CM_PRIVATE;
      alloced_color++;
    } else if (XAllocColor(dsp, DefaultColormap(dsp, scr), &col)) {
      coltbl[i] = CM_ALLOCED | CM_UPDATING;
      alloced_common_color++;
      alloced_color++;
    } else {
      fprintf(stderr, "color %d %d %d cannot allocated!\n",
	      p->red, p->green, p->blue);
      col.pixel = bg;
    }
    pixtbl[i] = col.pixel;
  }
}

get_color(p, n)
     COL *p;
{
  int i;

  for (i = 0; i < n; i++) {
    get_color_sub(i, p);
    if (i < MAXCOLSET) {
      XSetForeground(dsp, colgc[i], pixtbl[i]);
      XClearArea(dsp, colwin[i], 0, 0, 0, 0, True);
    }
    p++;
  }
  return i;
}

get_requested_colors()
{
  int i;
  
  for (i = 0; i < MAXCOLSET*MAXPALSET; i++) {
    if (coltbl[i] & CM_REQUEST)
      get_color_sub(i, &color_buf[i]);
  }
}

request_color(p)
     COL *p;
{
  int i;
  
  for (i = 0; i < MAXCOLSET*MAXPALSET; i++) {
    if (!(coltbl[i] & (CM_ALLOCED|CM_REQUEST))) {
      coltbl[i] = CM_REQUEST;
      color_buf[i].red = p->red;
      color_buf[i].green = p->green;
      color_buf[i].blue = p->blue;
      return i;
    }
  }
  return -1;
}

init_color()
{
  alloced_color = 0;
  memset(coltbl, 0, sizeof(coltbl));
}

/* free common color cells */
free_color()
{
  int i;

  for (i = 0; i < MAXPALSET*MAXCOLSET; i++) {
    if ((coltbl[i] & CM_ALLOCED)&&!(coltbl[i] & CM_PRIVATE)) {
      XFreeColors(dsp, DefaultColormap(dsp, scr), pixtbl+i, 1, 0);
      --alloced_color;
      coltbl[i] = 0;
    }
  }
}

/* free common and private color cells */
free_color_all()
{
  int i;

  for (i = 0; i < MAXPALSET*MAXCOLSET; i++) {
    if (coltbl[i] & CM_ALLOCED) {
      XFreeColors(dsp, DefaultColormap(dsp, scr), pixtbl+i, 1, 0);
      --alloced_color;
      coltbl[i] = 0;
    }
  }
}

init_image()
{
  if (!alloced_color)
    get_color(color_buf+MAXCOLSET*current_pal, MAXCOLSET);
  memset(img->data, 0, img->bytes_per_line * img->height);
}

int set_image_size(w, h)
{
  int r;

  r = 0;
  if (w >= 0) {
    imgfilew = w;
    r = 1;
  }
  if (h >= 0) {
    imgfileh = h;
    r |= 2;
  }
  info_imgsize_set();
  return r;
}

void draw_grid(x0, y0, w0, h0)
{
  int n, x, y, w, h;

  n = grid_size*zoomfactor;
  w = w0;
  x = x0;
  if (x & 1) {
    x++;
    w--;
  }
  if (w > 0 && h0 > 0) {
    for (y = y0; y < y0 + h0; y++) {
      if (((imgofsy + y)%n) == 0)
	XDrawLine(dsp, imgwin, gridgc, x, y, x+w-1, y);
    }
  }
  h = h0;
  y = y0;
  if (y & 1) {
    y++;
    h--;
  }
  if (w0 > 0 && h > 0) {
    for (x = x0; x < x0 + w0; x++) {
      if (((imgofsx + x)%n) == 0)
	XDrawLine(dsp, imgwin, gridgc, x, y, x, y+h-1);
    }
  }
}

void img_expose(x, y, w, h)
{
  int i;
  
  if ((imgofsx+x >= imgfilew*zoomfactor)||
      (imgofsy+y >= imgfileh*zoomfactor)||
      (imgofsx+x+w < 0)||
      (imgofsy+y+h < 0)) {
    XClearArea(dsp, imgwin, x, y, w, h, False);
    return;
  }
  i = -imgofsx - x;
  if (i > 0) {
    XClearArea(dsp, imgwin, x, y, i, h, False);
    x += i;
    w -= i;
  }
  i = -imgofsy - y;
  if (i > 0) {
    XClearArea(dsp, imgwin, x, y, w, i, False);
    y += i;
    h -= i;
  }
  i = x + w - (imgfilew*zoomfactor - imgofsx);
  if (i > 0) {
    XClearArea(dsp, imgwin, x+w-i, y, i, h, False);
    w -= i;
  }
  i = y + h - (imgfileh*zoomfactor - imgofsy);
  if (i > 0) {
    XClearArea(dsp, imgwin, x, y+h-i, w, i, False);
    h -= i;
  }
  if (w&&h) {
    XPutImage(dsp, imgwin, gc0, img, x+imgofsx, y+imgofsy, x, y, w, h);
    if (grid_mode)
      draw_grid(x, y, w, h);
  }
}

image_update_all_sub()
{
  img_expose(0, 0, imgwinwidth, imgwinheight);
  if (view_sw & 1)
    XClearArea(dsp, viewwin, 0, 0, 0, 0, True);
}

void image_update_all()
{
  make_view_image();
  gen_image_sub(0, 0, imgfilew, imgfileh);
  image_update_all_sub();
}

void image_update_col()
{
  make_view_image();
  gen_image_col(0, 0, imgfilew, imgfileh);
  image_update_all_sub();
}

void color_update_all()
{
  int i;
  
  free_color();
  get_color(color_buf+MAXCOLSET*current_pal, MAXCOLSET);
  if (alloced_common_color)
    image_update_col();
}

init_color_buf()
{
  int i;
  static COL initdata[16] = {
    {  0,  0,  0},{  0,  0,255},{255,  0,  0},{255,  0,255},
    {  0,255,  0},{  0,255,255},{255,255,  0},{127,127,127},
    { 64, 64, 64},{127,127,255},{255,127,127},{255,127,255},
    {127,255,127},{127,255,255},{255,255,127},{255,255,255}
  };
  static COL initdata1[16] = {
    {255,255,255},{  0,  0,  0},{ 32, 32, 32},{ 48, 48, 48},
    { 64, 64, 64},{ 80, 80, 80},{ 96, 96, 96},{128,128,128},
    {144,144,144},{160,160,160},{176,176,176},{192,192,192},
    {208,208,208},{224,224,224},{240,240,240},{255,255,255}
  };
  static COL initdata2[16] = {
    {  0,  0,  0},{ 16, 16, 16},{ 32, 32, 32},{ 48, 48, 48},
    { 64, 64, 64},{ 80, 80, 80},{ 96, 96, 96},{128,128,128},
    {144,144,144},{160,160,160},{176,176,176},{192,192,192},
    {208,208,208},{224,224,224},{240,240,240},{255,255,255}
  };
  
  for (i = 0; i < MAXPALSET; i++)
    memcpy(color_buf+i*MAXCOLSET, initdata, sizeof(COL)*MAXCOLSET);
  memcpy(color_buf+MAXCOLSET, initdata1, sizeof(COL)*MAXCOLSET);
  memcpy(color_buf+MAXCOLSET*2, initdata2, sizeof(COL)*MAXCOLSET);
}

image_alloc()
{
  imgdata = (unsigned char *)malloc(imgmaxw*imgmaxh);
  if (imgdata == NULL) {
    fprintf(stderr, "more core!\n");
    exit(1);
  }
  img = XCreateImage(dsp, DefaultVisual(dsp, scr), DefaultDepth(dsp, scr),
		     ZPixmap, 0, None,
		     imgmaxw*maxzoom, imgmaxh*maxzoom,
		     32, 0);
  if (img == NULL) {
    fprintf(stderr, "more core!");
    exit(1);
  }
  img->data = (char *)malloc(img->bytes_per_line * img->height);
  if (img->data == NULL) {
    fprintf(stderr, "more core!\n");
    exit(1);
  }
}

resize_scrl()
{
  XMoveResizeWindow(dsp, scrlwin[0], IMGX, IMGY-IMGSCRLW-1, imgwinwidth, IMGSCRLW);
  XMoveResizeWindow(dsp, scrlwin[1], IMGX, IMGY+imgwinheight+1, imgwinwidth, IMGSCRLW);
  XMoveResizeWindow(dsp, scrlwin[2], IMGX-IMGSCRLW-1, IMGY, IMGSCRLW, imgwinheight);
  XMoveResizeWindow(dsp, scrlwin[3], IMGX+imgwinwidth+1, IMGY, IMGSCRLW, imgwinheight);
}

get_img_window_size()
{
  XWindowAttributes attr;

  XGetWindowAttributes(dsp, win, &attr);
  imgwinwidth = attr.width - IMGX - IMGSCRLW - 16;
  if (imgwinwidth > IMGWINWIDTHMAX)
    imgwinwidth = IMGWINWIDTHMAX;
  imgwinheight = attr.height - IMGY - IMGSCRLW - 16;
  if (imgwinheight > IMGWINHEIGHTMAX)
    imgwinheight = IMGWINHEIGHTMAX;
}

resize_img_window()
{
  get_img_window_size();
  XResizeWindow(dsp, imgwin, imgwinwidth, imgwinheight);
  resize_scrl();
}

create_img_window()
{
  int i;

  get_img_window_size();
  for (i = 0; i < 4; i++)
    scrlwin[i] = XCreateSimpleWindow(dsp, win, IMGX, IMGY, 1, 1, 1, fg, bg);
  imgwin = XCreateSimpleWindow(dsp, win, IMGX, IMGY,
			       imgwinwidth, imgwinheight, 1, fg, bg);
  resize_scrl();
  XSelectInput(dsp, imgwin, ExposureMask|OwnerGrabButtonMask|
	       ButtonPressMask|ButtonReleaseMask|ButtonMotionMask);
  XMapRaised(dsp, imgwin);
  for (i = 0; i < 4; i++) {
    XSelectInput(dsp, scrlwin[i], ExposureMask|
		 EnterWindowMask|LeaveWindowMask|
		 ButtonPressMask|ButtonReleaseMask);
    XMapRaised(dsp, scrlwin[i]);
  }
}

close_img_window()
{
  int i;
  
  XDestroyWindow(dsp, imgwin);
  for (i = 0; i < 4; i++)
    XDestroyWindow(dsp, scrlwin[i]);
}

static int imgscrl_dir_mask[4] = {1, 2, 4, 8};

imgscrl_expose(ev)
     XEvent *ev;
{
  int i;
  static char *name[4] = {"^", "v", "<", ">"};
  
  for (i = 0; i < 4; i++) {
    if (ev->xexpose.window == scrlwin[i]) {
      menuwin_center(scrlwin[i], name[i], scrl_dir & imgscrl_dir_mask[i]);
      break;
    }
  }
}

img_scroll(dx, dy)
{
  if (scroll_stop & 1) {
    if (dx) {
      if (imgofsx + dx + imgwinwidth >= imgfilew*zoomfactor)
	dx = imgfilew*zoomfactor - (imgofsx + imgwinwidth);
      if (imgofsx + dx < 0)
	dx = -imgofsx;
    }
    if (dy) {
      if (imgofsy + dy + imgwinheight >= imgfileh*zoomfactor)
	dy = imgfileh*zoomfactor - (imgofsy + imgwinheight);
      if (imgofsy + dy < 0)
	dy = -imgofsy;
    }
  }
  if (dx) {
    imgofsx += dx;
    XClearArea(dsp, cursmenu[CURS_TOPX].win, 0, 0, 0, 0, True);
  }
  if (dy) {
    imgofsy += dy;
    XClearArea(dsp, cursmenu[CURS_TOPY].win, 0, 0, 0, 0, True);
  }
  if (imgwin_noexpose) {
    XCopyArea(dsp, imgwin, imgwin, gc0,
	      (dx<0?0:dx), (dy<0?0:dy),
	      imgwinwidth-(dx<0?-dx:dx), imgwinheight-(dy<0?-dy:dy),
	      (dx<0?-dx:0), (dy<0?-dy:0));
    imgwin_noexpose = 0;
    if (dx)
      img_expose((dx<0?0:imgwinwidth-dx), 0, (dx<0?-dx:dx), imgwinheight);
    if (dy)
      img_expose(0, (dy<0?0:imgwinheight-dy), imgwinwidth, (dy<0?-dy:dy));
  } else {
    img_expose(0, 0, imgwinwidth, imgwinheight);
  }
}

little_big(p1, p2)
     int *p1;
     int *p2;
{
  int i;
  
  if (*p1 > *p2) {
    i = *p1;
    *p1 = *p2;
    *p2 = i;
  }
}

calc_area(x0, y0, x1, y1)
     int *x0;
     int *y0;
     int *x1;
     int *y1;
{
  int i;
  
  little_big(x0, x1);
  little_big(y0, y1);
  *x1 = (*x1 - *x0) * zoomfactor;
  *y1 = (*y1 - *y0) * zoomfactor;
  *x0 = *x0 * zoomfactor - imgofsx;
  *y0 = *y0 * zoomfactor - imgofsy;
}

copy_area_erase()
{
  int x, y, w, h;

  x = lastcopypos0.x;
  y = lastcopypos0.y;
  w = lastcopypos1.x;
  h = lastcopypos1.y;
  calc_area(&x, &y, &w, &h);
  img_expose(x, y, w+1, 1);
  img_expose(x, y, 1, h+1);
  img_expose(x+w, y, 1, h+1);
  img_expose(x, y+h, w+1, 1);
}

copy_area_expose()
{
  int x, y, w, h;

  copy_area_erase();
  
  x = copypos0.x;
  y = copypos0.y;
  w = copypos1.x;
  h = copypos1.y;
  calc_area(&x, &y, &w, &h);
  XDrawRectangle(dsp, imgwin, areagc, x, y, w, h);

  lastcopypos0 = copypos0;
  lastcopypos1 = copypos1;
}

img_button(ox, oy, st)
{
  int x, y, dx, dy, w, h;
  unsigned long pix;
  static int bstat = 0;

  switch (st) {
  case 1:
    bstat |= 1;
    break;
  case 0x81:
    bstat &= ~1;
    break;
  case 2:
    bstat |= 2;
    break;
  case 0x82:
    bstat &= ~2;
    break;
  case 3:
    bstat |= 4;
    break;
  case 0x83:
    bstat &= ~4;
    break;
  }
  if (ox < 0 || ox >= imgwinwidth ||
      oy < 0 || oy >= imgwinheight)
    return;
  x = (ox + imgofsx) / zoomfactor;
  y = (oy + imgofsy) / zoomfactor;
  if (x != curx) {
    curx = x;
    XClearArea(dsp, cursmenu[CURS_CURX].win, 0, 0, 0, 0, True);
  }
  if (y != cury) {
    cury = y;
    XClearArea(dsp, cursmenu[CURS_CURY].win, 0, 0, 0, 0, True);
  }
  if (x < 0 || x >= imgfilew || y < 0 || y >= imgfileh)
    return;
  switch (edit_mode) {
  case EDIT_PLOT:
    if (bstat & 1 && current_col >= 0) {
      setpixelcolor(x, y, current_col);
      if (vimg != NULL)
	XClearArea(dsp, viewwin, x, y, 1, 1, True);
      if ((x = ox - ((imgofsx+ox)%zoomfactor)) < 0)
	x = 0;
      if ((y = oy - ((imgofsy+oy)%zoomfactor)) < 0)
	y = 0;
      img_expose(x, y, zoomfactor, zoomfactor);
    } else if (bstat & (2|4)) {
      int oldcol;
      
      oldcol = current_col;
      current_col = *(imgdata+y*imgmaxw+x);
      if (current_col != oldcol) {
	if (oldcol >= 0)
	  XClearArea(dsp, colwin[oldcol], 0, 0, 0, 0, True);
	if (current_col >= 0)
	  XClearArea(dsp, colwin[current_col], 0, 0, 0, 0, True);
      }
    }
    break;
  case EDIT_COPY:
    if (st == 1) {
      switch(copy_mode) {
      case 2:
	if (copypos0.x <= x && x <= copypos1.x &&
	    copypos0.y <= y && y <= copypos1.y) {
	  /* area catch */
	  copyposd0.x = x - copypos0.x;
	  copyposd0.y = y - copypos0.y;
	  copyposd1.x = x - copypos1.x;
	  copyposd1.y = y - copypos1.y;
	  copy_mode = 3;
	  break;
	}
	copy_area_erase();
      case 0:
	/* area mark start */
	copypos0.x = x;
	copypos0.y = y;
	copy_mode = 1;
	break;
      }
    } else if (st == 0x81) {
      switch(copy_mode) {
      case 3:
	/* paste */
	copy_area(copypos0.x, copypos0.y, copysrc.x, copysrc.y,
		  copypos1.x - copypos0.x, copypos1.y - copypos0.y);
	x = copypos0.x;
	y = copypos0.y;
	w = copypos1.x;
	h = copypos1.y;
	calc_area(&x, &y, &w, &h);
	img_expose(x, y, w, h);
	copy_area_expose();
      case 1:
	/* area mark end */
	little_big(&copypos0.x, &copypos1.x);
	little_big(&copypos0.y, &copypos1.y);
	copysrc = copypos0;
	copy_mode = 2;
	break;
      }
    }
    if (bstat & 1) {
      switch(copy_mode) {
      case 1:
	/* area update */
	if (x != copypos1.x || y != copypos1.y) {
	  copypos1.x = x;
	  copypos1.y = y;
	  copy_area_expose();
	}
	break;
      case 3:
	if (x != copypos0.x + copyposd0.x || y != copypos0.y + copyposd0.y) {
	  copypos0.x = x - copyposd0.x;
	  copypos0.y = y - copyposd0.y;
	  copypos1.x = x - copyposd1.x;
	  copypos1.y = y - copyposd1.y;
	  copy_area_expose();
	}
	break;
      }
    }
    if (bstat & (2|4)) {
      copy_area_erase();
      copy_mode = 0;
    }
    break;
  }
}

imgscrl_press(ev)
     XEvent *ev;
{
  int i;
  
  for (i = 0; i < 4; i++) {
    if (ev->xbutton.window == scrlwin[i]) {
      scrl_dir |= imgscrl_dir_mask[i];
      XClearArea(dsp, scrlwin[i], 0, 0, 0, 0, True);
      break;
    }
  }
}

imgscrl_release(ev)
     XEvent *ev;
{
  int i;
  
  for (i = 0; i < 4; i++) {
    if (ev->xbutton.window == scrlwin[i]) {
      scrl_dir &= ~imgscrl_dir_mask[i];
      XClearArea(dsp, scrlwin[i], 0, 0, 0, 0, True);
      break;
    }
  }
}

imgscrl_enter(ev)
     XEvent *ev;
{
  int i;
  
  for (i = 0; i < 4; i++) {
    if (ev->xcrossing.window == scrlwin[i]) {
      menuwin_highlight(scrlwin[i], scrl_dir & imgscrl_dir_mask[i]);
      break;
    }
  }
}

imgscrl_background()
{
  if (scrl_dir & imgscrl_dir_mask[0])
    img_scroll(0, -scroll_speed);
  if (scrl_dir & imgscrl_dir_mask[1])
    img_scroll(0, scroll_speed);
  if (scrl_dir & imgscrl_dir_mask[2])
    img_scroll(-scroll_speed, 0);
  if (scrl_dir & imgscrl_dir_mask[3])
    img_scroll(scroll_speed, 0);
}

key_event(ev)
     XEvent *ev;
{
  int i;
  char buf[32];
  KeySym key;
  XComposeStatus cs;
  
  i = XLookupString((XKeyEvent *)ev, buf, sizeof(buf)-1, &key, &cs);
  buf[i] = '\0';
  switch(buf[0]) {
  case 0x03:
  case 'q':
    menu_stat_change(MENU_QUIT, 2);
    break;
  case 'f':
    menu_stat_change(MENU_FILE, 2);
    break;
  case 'i':
    menu_stat_change(MENU_INFO, 2);
    break;
  case 'e':
    menu_stat_change(MENU_EDIT, 2);
    break;
  case '-':
    zoom_out();
    break;
  case '+':
    zoom_in();
    break;
  case 'L'-0x40:
    XClearArea(dsp, imgwin, 0, 0, 0, 0, True);
    break;
  case '2':
  case 'j':
    img_scroll(0, scroll_speed);
    break;
  case '8':
  case 'k':
    img_scroll(0, -scroll_speed);
    break;
  case '6':
  case 'l':
    img_scroll(scroll_speed, 0);
    break;
  case '4':
  case 'h':
    img_scroll(-scroll_speed, 0);
    break;
  case '1':
    img_scroll(-scroll_speed, scroll_speed);
    break;
  case '3':
    img_scroll(scroll_speed, scroll_speed);
    break;
  case '7':
    img_scroll(-scroll_speed, -scroll_speed);
    break;
  case '9':
    img_scroll(scroll_speed, -scroll_speed);
    break;
  case 'p':
    edit_mode_change(EDIT_PLOT);
    break;
  case 'c':
    edit_mode_change(EDIT_COPY);
    break;
  }
}

f_display(ac, av)
     int *ac; char ***av;
{
  if (*ac > 1) {
    --*ac;
    ++*av;
    str_display = **av;
  }
}

f_geometry(ac, av)
     int *ac; char ***av;
{
  if (*ac > 1) {
    --*ac;
    ++*av;
    str_geometry = **av;
  }
}

f_background(ac, av)
     int *ac; char ***av;
{
  if (*ac > 1) {
    --*ac;
    ++*av;
    str_background = **av;
  }
}

f_foreground(ac, av)
     int *ac; char ***av;
{
  if (*ac > 1) {
    --*ac;
    ++*av;
    str_foreground = **av;
  }
}

f_font(ac, av)
     int *ac; char ***av;
{
  if (*ac > 1) {
    --*ac;
    ++*av;
    str_font = **av;
  }
}

f_fontbold(ac, av)
     int *ac; char ***av;
{
  if (*ac > 1) {
    --*ac;
    ++*av;
    str_fontbold = **av;
  }
}

f_commoncolor(ac, av)
     int *ac; char ***av;
{
  use_private_color = 0;
}

f_maxw(ac, av)
     int *ac; char ***av;
{
  int i;
  
  if (*ac > 1) {
    --*ac;
    ++*av;
    i = strtol(**av, NULL, 0);
    if (i)
      imgmaxw = i;
  }
}

f_maxh(ac, av)
     int *ac; char ***av;
{
  int i;
  
  if (*ac > 1) {
    --*ac;
    ++*av;
    i = strtol(**av, NULL, 0);
    if (i)
      imgmaxh = i;
  }
}

f_maxz(ac, av)
     int *ac; char ***av;
{
  int i;
  
  if (*ac > 1) {
    --*ac;
    ++*av;
    i = strtol(**av, NULL, 0);
    if (i)
      maxzoom = i;
  }
}

struct {
  char *name;
  int (*func)();
} opttbl[] = {
  {"-display", f_display},
  {"-geometry", f_geometry},
  {"-background", f_background},
  {"-foreground", f_foreground},
  {"-bg", f_background},
  {"-fg", f_foreground},
  {"-fn", f_font},
  {"-fb", f_fontbold},
  {"-commoncolor", f_commoncolor},
  {"-maxw", f_maxw},
  {"-maxh", f_maxh},
  {"-maxz", f_maxz},
  {"-?", usage},
  {"-h", usage},
  {"-help", usage},
  {NULL, NULL}
};

create_icon()
{
#ifdef INTERNAL_ICONPIXMAP
  icon_pixmap = XCreateBitmapFromData(dsp, DefaultRootWindow(dsp), 
				      icon_bits, icon_width, icon_height);
  if (icon_pixmap == None) {
    fprintf(stderr, "icon pixmap create error!\n");
    return 1;
  }
  return 0;
#endif /* INTERNAL_ICONPIXMAP */
}

free_icon()
{
  if (icon_pixmap != None)
    XFreePixmap(dsp, icon_pixmap);
}

main(argc, argv)
     int argc; char **argv;
{
  XSizeHints hint;
  XEvent ev;
  char buf[256];
  int oargc;
  char **oargv;
  int i;
  Window double_click_win = 0;
  Time l, double_click_time;
  XColor col;

  oargc = argc;
  oargv = argv;
  myname = filename(*argv);
  while (--argc && **++argv == '-') {
    for (i = 0; opttbl[i].name != NULL; i++) {
      if (strcmp(*argv, opttbl[i].name) == 0) {
	opttbl[i].func(&argc, &argv);
	break;
      }
    }
  }
  dsp = XOpenDisplay(str_display);
  if (!dsp) {
    fprintf(stderr, "Cannot open display!\n");
    exit(1);
  }
  scr = DefaultScreen(dsp);
  if (!XParseColor(dsp, DefaultColormap(dsp, scr), str_background, &col)||
      !XAllocColor(dsp, DefaultColormap(dsp, scr), &col)) {
    fprintf(stderr, "``%s'' color alloc error!\n", str_background);
    exit(1);
  }
  bg = col.pixel;
  if (!XParseColor(dsp, DefaultColormap(dsp, scr), str_foreground, &col)||
      !XAllocColor(dsp, DefaultColormap(dsp, scr), &col)) {
    fprintf(stderr, "``%s'' color alloc error!\n", str_foreground);
    exit(1);
  }
  fg = col.pixel;
  create_icon();
  hint.flags = 0;
  i = XGeometry(dsp, scr, str_geometry, "428x368", 2, 1, 1, 0, 0,
		&(hint.x), &(hint.y), &(hint.width), &(hint.height));
  if (i & (XValue|YValue))
    hint.flags |= PPosition;
  if (i & (WidthValue|HeightValue))
    hint.flags |= PSize;
  win = XCreateSimpleWindow(dsp, DefaultRootWindow(dsp),
			    hint.x, hint.y, hint.width, hint.height,
			    2, fg, bg);
  XSetStandardProperties(dsp, win, *oargv, *oargv, icon_pixmap,
			 oargv, oargc, &hint);

  if (str_fontbold == NULL)
    str_fontbold = str_font == NULL ? DEFAULT_BOLD_FONT : str_font;
  if (str_font == NULL)
    str_font = DEFAULT_FONT;

  fs0 = XLoadQueryFont(dsp, str_font);
  gc0 = XCreateGC(dsp, win, 0, 0);
  XSetBackground(dsp, gc0, bg);
  XSetForeground(dsp, gc0, fg);
  XSetFont(dsp, gc0, fs0->fid);

  fs1 = XLoadQueryFont(dsp, str_fontbold);
  gc1 = XCreateGC(dsp, win, 0, 0);
  XSetBackground(dsp, gc1, fg);
  XSetForeground(dsp, gc1, bg);
  XSetFont(dsp, gc1, fs1->fid);

  areagc = XCreateGC(dsp, win, 0, 0);
  XSetBackground(dsp, areagc, bg);
  XSetForeground(dsp, areagc, fg);

  gridgc = XCreateGC(dsp, win, 0, 0);
  XSetBackground(dsp, gridgc, bg);
  XSetForeground(dsp, gridgc, bg);
  XSetLineAttributes(dsp, gridgc, 0, LineOnOffDash, CapButt, JoinMiter);
  XSetDashes(dsp, gridgc, 0, grid_dash_list, 2);

  create_img_window();

  create_menu_window(MENUX, MENUY);
  create_colset_window(COLSETX, COLSETY);
  create_palset_window(PALSETX, PALSETY);
  create_filename_window();
  create_zoom_window(256, 4);
  create_grid_window(340, 4);
  create_cursor_window(256, 32);
  image_alloc();
  
  init_color_buf();
  init_color();
  init_image();
  image_update_all();
  while (argc--)
    read_data_file(*argv++);
  XSelectInput(dsp, win, ExposureMask|StructureNotifyMask|
	       ButtonPressMask|KeyPressMask);
  XMapRaised(dsp, win);
  while (!sw_quit) {
    if (XEventsQueued(dsp, QueuedAfterFlush) == 0) {
      imgscrl_background();
      file_background();
    }
    XNextEvent(dsp, &ev);
    switch(ev.type) {
    case NoExpose:
      if (ev.xexpose.window == imgwin)
	imgwin_noexpose = 1;
      break;
    case GraphicsExpose:
      if (ev.xgraphicsexpose.drawable == imgwin) {
	img_expose(ev.xgraphicsexpose.x, ev.xgraphicsexpose.y,
		   ev.xgraphicsexpose.width, ev.xgraphicsexpose.height);
	if (ev.xgraphicsexpose.count == 0)
	  imgwin_noexpose = 1;
      }
      file_expose(&ev);
      break;
    case Expose:
      if (ev.xexpose.window == win) {
      } else if (ev.xexpose.window == imgwin) {
	img_expose(ev.xexpose.x, ev.xexpose.y,
		   ev.xexpose.width, ev.xexpose.height);
      } else {
	filename_expose(&ev);
	imgscrl_expose(&ev);
	menu_expose(&ev);
	colset_expose(&ev);
	palset_expose(&ev);
	file_expose(&ev);
	zoom_expose(&ev);
	grid_expose(&ev);
	cursor_expose(&ev);
	info_expose(&ev);
	edit_expose(&ev);
      }
      break;
    case MappingNotify:
      XRefreshKeyboardMapping((XMappingEvent *)&ev);
      break;
    case KeyPress:
      if (file_keypress(&ev) == 0 &&
	  info_keypress(&ev) == 0)
	key_event(&ev);
      break;
    case ConfigureNotify:
      if (ev.xconfigure.window == win) {
	resize_img_window();
	update_infowin();
      }
      break;
    case MotionNotify:
      if (ev.xmotion.window == imgwin) {
	img_button(ev.xmotion.x, ev.xmotion.y, 0);
      }
      break;
    case ButtonPress:
      if (ev.xbutton.window == double_click_win) {
	l = ev.xbutton.time - double_click_time;
	if (l & 0x80000000)
	  l = ~l + 1;
	double_clicked = l < 500;
      } else {
	double_clicked = 0;
      }
      double_click_win = ev.xbutton.window;
      double_click_time = ev.xbutton.time;
      if (ev.xbutton.window == win) {
	switch(ev.xbutton.button) {
	case 1:
	  break;
	}
      } else if (ev.xbutton.window == imgwin) {
	img_button(ev.xbutton.x, ev.xbutton.y, ev.xbutton.button);
      }
      imgscrl_press(&ev);
      menu_press(&ev);
      colset_button(&ev);
      palset_button(&ev);
      file_button(&ev);
      zoom_press(&ev);
      grid_press(&ev);
      cursor_press(&ev);
      info_press(&ev);
      edit_press(&ev);
      break;
    case ButtonRelease:
      if (ev.xbutton.window == imgwin) {
	img_button(ev.xbutton.x, ev.xbutton.y, 0x80|ev.xbutton.button);
      }
      imgscrl_release(&ev);
      file_release(&ev);
      break;
    case EnterNotify:
      double_click_win = 0;
      imgscrl_enter(&ev);
      menu_enter(&ev);
      colset_enter(&ev);
      palset_enter(&ev);
      file_enter(&ev);
      zoom_enter(&ev);
      grid_enter(&ev);
      cursor_enter(&ev);
      info_enter(&ev);
      edit_enter(&ev);
      break;
    case LeaveNotify:
      double_click_win = 0;
      if (!file_leave(&ev) &&
	  !info_leave(&ev) &&
	  !menu_leave(&ev) &&
	  !zoom_leave(&ev) &&
	  !grid_leave(&ev) &&
	  !edit_leave(&ev))
	XClearArea(dsp, ev.xcrossing.window, 0, 0, 0, 0, True);
      break;
    }
  }
  close_edit_window();
  close_info_window();
  close_cursor_window();
  close_grid_window();
  close_zoom_window();
  close_filename_window();
  close_file_window();
  close_palset_window();
  close_colset_window();
  close_menu_window();
  close_img_window();
  free_color_all();
  free_icon();
  XFree((char *)img);
  XFreeGC(dsp, gc1);
  XFreeGC(dsp, gc0);
  XDestroyWindow(dsp, win);
  XCloseDisplay(dsp);
  exit(0);
}

/* End of file */
