/* $Header: /ext/yav/catty/xpx/RCS/menu.c,v 1.11 1994/02/02 07:14:18 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"
#include "menudef.h"

#define MAXMENU 4
#define BDW 1
#define MENUW 52
#define MENUH 18

static int menu_sw[MAXMENU];

static MENU menutbl[] = {
  {
    MENU_QUIT,
    (MENUW+BDW)*0, 0, MENUW, MENUH,
    0, EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    0, 0, BDW,
    NULL, "Quit"},
  {
    MENU_FILE,
    (MENUW+BDW)*1, 0, MENUW, MENUH,
    0, EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    0, 0, BDW,
    NULL, "File"},
  {
    MENU_INFO,
    (MENUW+BDW)*2, 0, MENUW, MENUH,
    0, EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    0, 0, BDW,
    NULL, "Info"},
  {
    MENU_EDIT,
    (MENUW+BDW)*3, 0, MENUW, MENUH,
    0, EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    0, 0, BDW,
    NULL, "Edit"},
  {
    -1,
    0, 0, 0, 0,
    0, 0, 0,
    0, 0, 0,
    NULL, ""}};

create_menu_window(x, y)
{
  menuwin_create(menutbl, win, x, y);
  return 0;
}

close_menu_window()
{
  menuwin_destroy(menutbl);
}

menu_expose(ev)
     XEvent *ev;
{
  menuwin_expose(menutbl, ev);
}

menu_stat_change(i, s)
{
  switch(s) {
  case 0:
    menutbl[i].mode &= ~MenuModeMaskOn;
    break;
  case 1:
    menutbl[i].mode |= MenuModeMaskOn;
    break;
  case 2:
    menutbl[i].mode ^= MenuModeMaskOn;
    break;
  }
  XClearArea(dsp, menutbl[i].win, 0, 0, 0, 0, True);
  switch(i) {
  case MENU_QUIT:
    sw_quit = 1;
    break;
  case MENU_FILE:
    if (menutbl[i].mode & MenuModeMaskOn)
      create_file_window(500, 200);
    else
      unmap_file_window();
    break;
  case MENU_INFO:
    if (menutbl[i].mode & MenuModeMaskOn)
      create_info_window(500, 100);
    else
      unmap_info_window();
    break;
  case MENU_EDIT:
    if (menutbl[i].mode & MenuModeMaskOn)
      create_edit_window(500, 100);
    else
      unmap_edit_window();
    break;
  }
}

menu_press(ev)
     XEvent *ev;
{
  int i;

  i = menuwin_press(menutbl, ev);
  if (i >= 0) {
    XClearArea(dsp, menutbl[i].win, 0, 0, 0, 0, True);
    menu_stat_change(i, -1);
  }
}

menu_enter(ev)
     XEvent *ev;
{
  menuwin_enter(menutbl, ev);
}

menu_leave(ev)
     XEvent *ev;
{
  return menuwin_leave(menutbl, ev) >= 0;
}

/* End of file */
