/* $Header: /ext/yav/catty/xpx/RCS/palset.c,v 1.8 1994/01/23 17:05:21 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"

#define BDW 1
#define PALSETW 24
#define PALSETH 18

static Window palwin[MAXPALSET];

create_palset_window(x, y)
{
  int i;

  for (i = 0; i < MAXPALSET; i++) {
    palwin[i] = XCreateSimpleWindow(dsp, win, x, y, PALSETW, PALSETH,
				    BDW, fg, bg);
    XSelectInput(dsp, palwin[i],
		 ButtonPressMask|ExposureMask|EnterWindowMask|LeaveWindowMask);
    XMapRaised(dsp, palwin[i]);
    y += PALSETH+BDW;
  }
  return 0;
}

close_palset_window()
{
  int i;
  
  for (i = 0; i < MAXPALSET; i++)
    XDestroyWindow(dsp, palwin[i]);
}

palset_expose(ev)
     XEvent *ev;
{
  int i;
  char buf[256];
  
  if (ev->xexpose.count == 0) {
    for (i = 0; i < MAXPALSET; i++) {
      if (ev->xexpose.window == palwin[i]) {
	sprintf(buf, "%d", i);
	menuwin_center(palwin[i], buf, i == current_pal);
	return;
      }
    }
  }
}

palset_button(ev)
     XEvent *ev;
{
  int i, oldpal;

  for (i = 0; i < MAXPALSET; i++) {
    if (ev->xbutton.window == palwin[i]) {
      switch(ev->xbutton.button) {
      case 1:
	if (i != current_pal) {
	  oldpal = current_pal;
	  current_pal = i;
	  XClearArea(dsp, palwin[oldpal], 0, 0, 0, 0, True);
	  XClearArea(dsp, palwin[current_pal], 0, 0, 0, 0, True);
	  color_update_all();
	}
      }
    }
  }
}

palset_enter(ev)
     XEvent *ev;
{
  int i;

  for (i = 0; i < MAXPALSET; i++) {
    if (ev->xcrossing.window == palwin[i])
      menuwin_highlight(palwin[i], i == current_pal);
  }
}

/* End of file */
