/* $Header: /ext/yav/catty/xpx/RCS/sub.c,v 1.7 1994/02/02 07:13:33 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"

draw_hbox_gc(w, g)
     Window w;
     GC g;
{
  XWindowAttributes attr;
  
  XGetWindowAttributes(dsp, w, &attr);
  XDrawRectangle(dsp, w, g, 0, 0, attr.width-1, attr.height-1);
}

menuwin_highlight(wd, sw)
     Window wd;
     int sw;
{
  draw_hbox_gc(wd, (sw & MenuModeMaskOn)?gc1:gc0);
}

menuwin_strpos_center(wd, fs, str, xp, yp, lp, ascp, desp)
     Window wd;
     XFontStruct *fs;
     char *str;
     int *xp;
     int *yp;
     int *lp;
     int *ascp;
     int *desp;
{
  int len, w, dir, asc, des;
  XWindowAttributes attr;
  XCharStruct overall;
  
  XGetWindowAttributes(dsp, wd, &attr);
  len = strlen(str);
  w = XTextWidth(fs, str, len);
  XTextExtents(fs, str, 0, &dir, &asc, &des, &overall);
  if (xp != NULL)
    *xp = (attr.width-w)/2;
  if (yp != NULL)
    *yp = attr.height - (attr.height-(asc+des))/2 - des;
  if (lp != NULL)
    *lp = len;
  if (ascp != NULL)
    *ascp = asc;
  if (desp != NULL)
    *desp == des;
}

draw_center_string(wd, fs, gc, str)
     Window wd;
     XFontStruct *fs;
     GC gc;
     char *str;
{
  int x, y, len;
  
  menuwin_strpos_center(wd, fs, str, &x, &y, &len, NULL, NULL);
  XDrawString(dsp, wd, gc, x, y, str, len);
}

menuwin_normal(wd, str)
     Window wd;
     char *str;
{
  draw_center_string(wd, fs0, gc0, str);
}

menuwin_select(wd, str)
     Window wd;
     char *str;
{
  XWindowAttributes attr;
  
  XGetWindowAttributes(dsp, wd, &attr);
  XFillRectangle(dsp, wd, gc0, 0, 0, attr.width, attr.height);
  draw_center_string(wd, fs1, gc1, str);
}

menuwin_center(wd, str, sw)
     Window wd;
     char *str;
     int sw;
{
  if (sw & MenuModeMaskOn)
    menuwin_select(wd, str);
  else
    menuwin_normal(wd, str);
  if (sw & MenuModeMaskEnter)
    menuwin_highlight(wd, sw);
}

menuwin_lnormal(wd, str)
     Window wd;
     char *str;
{
  XWindowAttributes attr;
  
  XGetWindowAttributes(dsp, wd, &attr);
  XDrawString(dsp, wd, gc0, 2, attr.height-5, str, strlen(str));
}

menuwin_lselect(wd, str)
     Window wd;
     char *str;
{
  XWindowAttributes attr;
  
  XGetWindowAttributes(dsp, wd, &attr);
  XFillRectangle(dsp, wd, gc0, 0, 0, attr.width, attr.height);
  XDrawString(dsp, wd, gc1, 2, attr.height-5, str, strlen(str));
}

menuwin_left(wd, str, sw)
     Window wd;
     char *str;
     int sw;
{
  if (sw & MenuModeMaskOn)
    menuwin_lselect(wd, str);
  else
    menuwin_lnormal(wd, str);
  if (sw & MenuModeMaskEnter)
    menuwin_highlight(wd, sw);
}

draw_cursor(wd, str, pos)
     Window wd;
     char *str;
{
  int x, y, len, asc, des;

  menuwin_strpos_center(wd, fs0, str, &x, &y, &len, &asc, &des);
  if (len)
    x += XTextWidth(fs0, str, pos);
  XFillRectangle(dsp, wd, gc0, x, y-asc, 1, asc+des);
}

menuwin_create(p, parent, x0, y0)
     MENU *p;
     Window parent;
{
  XSetWindowAttributes attr;

  while (p->n >= 0) {
    p->win = 
      XCreateSimpleWindow(dsp, parent, x0 + p->x, y0 + p->y, p->w, p->h,
			  p->bdw, fg, bg);
    XSelectInput(dsp, p->win, ExposureMask|p->im);
    if (p->gr) {
      attr.win_gravity = p->gr;
      XChangeWindowAttributes(dsp, p->win, CWWinGravity, &attr);
    }
    XMapRaised(dsp, p->win);
    p++;
  }
}

menuwin_destroy(p)
     MENU *p;
{
  while (p->n >= 0) {
    XDestroyWindow(dsp, p->win);
    p++;
  }
}

menuwin_expose_sub(p)
     MENU *p;
{
  if (p->mode & MenuModeMaskLeft)
    menuwin_left(p->win, p->strfunc?p->strfunc(p):p->str, p->mode);
  else
    menuwin_center(p->win, p->strfunc?p->strfunc(p):p->str, p->mode);
  /* if highlight on , display input cursor */
  if ((p->im & KeyPressMask)&&(p->mode & MenuModeMaskEnter))
    draw_cursor(p->win, p->strfunc?p->strfunc(p):p->str, p->cursor);
}

menuwin_expose(p, ev)
     MENU *p;
     XEvent *ev;
{
  while (p->n >= 0) {
    if (ev->xexpose.window == p->win) {
      if (ev->xexpose.count == 0)
	menuwin_expose_sub(p);
      return p->n;
    }
    p++;
  }
  return -1;
}

menuwin_press(p, ev)
     MENU *p;
     XEvent *ev;
{
  while (p->n >= 0) {
    if (ev->xbutton.window == p->win) {
      if (p->im & ButtonPressMask)
	p->mode ^= MenuModeMaskOn;
      return p->n;
    }
    p++;
  }
  return -1;
}

menuwin_enter(p, ev)
     MENU *p;
     XEvent *ev;
{
  while (p->n >= 0) {
    if (ev->xcrossing.window == p->win) {
      if (p->im & (ButtonPressMask|KeyPressMask)) {
	p->mode |= MenuModeMaskEnter;		/* highlight on */
	XClearArea(dsp, p->win, 0, 0, 0, 0, True);
      }
      return p->n;
    }
    p++;
  }
  return -1;
}

menuwin_leave(p, ev)
     MENU *p;
     XEvent *ev;
{
  while (p->n >= 0) {
    if (ev->xcrossing.window == p->win) {
      if (p->im & (ButtonPressMask|KeyPressMask)) {
	p->mode &= ~MenuModeMaskEnter; /* highlight off */
	XClearArea(dsp, p->win, 0, 0, 0, 0, True);
      }
      return p->n;
    }
    p++;
  }
  return -1;
}

menuwin_keypress(p, ev, r)
     MENU *p;
     XEvent *ev;
     int *r;
{
  while (p->n >= 0) {
    if (ev->xkey.window == p->win) {
      *r = edit_string(ev, p->strfunc?p->strfunc(p):p->str,
		       sizeof(p->str), &p->cursor);
      return p->n;
    }
    p++;
  }
  return -1;
}

/* End of file */
