/* $Header: /ext/yav/catty/xpx/RCS/zoom.c,v 1.4 1994/02/02 07:13:54 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"
#include "zoomdef.h"

#define BDW 1
#define ZOOMW 24
#define ZOOMH 16

char *zoom_strfunc(p)
     MENU *p;
{
  sprintf(p->str, "%d", zoomfactor);
  return p->str;
}

static MENU zoommenu[] = {
  {
    ZOOM_OUT,
    0, 0, ZOOMW, ZOOMH,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    0, 0, BDW,
    NULL, "<"},
  {
    ZOOM_NUM,
    ZOOMW+BDW, 0, ZOOMW, ZOOMH,
    0, ExposureMask, 0,
    0, 0, BDW,
    zoom_strfunc, "1"},
  {
    ZOOM_IN,
    (ZOOMW+BDW)*2, 0, ZOOMW, ZOOMH,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    0, 0, BDW,
    NULL, ">"},
  {
    -1,
    0, 0, 0, 0,
    0, 0, 0,
    0, 0, 0,
    NULL, ""}};

create_zoom_window(x, y)
{
  menuwin_create(zoommenu, win, x, y);
}

close_zoom_window()
{
  menuwin_destroy(zoommenu);
}

zoom_expose(ev)
     XEvent *ev;
{
  menuwin_expose(zoommenu, ev);
}

zoom_change(n)
{
  zoomfactor = n;
  XClearArea(dsp, zoommenu[ZOOM_NUM].win, 0, 0, 0, 0, True);
  image_update_all();
}

zoom_in()
{
  zoommenu[ZOOM_IN].mode |= MenuModeMaskOn;
  menuwin_expose_sub(&zoommenu[ZOOM_IN]);
  if (zoomfactor < maxzoom)
    zoom_change(zoomfactor+1);
  zoommenu[ZOOM_IN].mode &= ~MenuModeMaskOn;
  menuwin_expose_sub(&zoommenu[ZOOM_IN]);
}

zoom_out()
{
  zoommenu[ZOOM_OUT].mode |= MenuModeMaskOn;
  menuwin_expose_sub(&zoommenu[ZOOM_OUT]);
  if (zoomfactor > 1)
    zoom_change(zoomfactor-1);
  zoommenu[ZOOM_OUT].mode &= ~MenuModeMaskOn;
  menuwin_expose_sub(&zoommenu[ZOOM_OUT]);
}

zoom_press(ev)
     XEvent *ev;
{
  int i, oldpal;

  i = menuwin_press(zoommenu, ev);
  if (i < 0)
    return;
  switch(i) {
  case ZOOM_OUT:
    if (ev->xbutton.button == 1)
      zoom_out();
    else
      zoom_change(1);
    break;
  case ZOOM_IN:
    if (ev->xbutton.button == 1)
      zoom_in();
    else
      zoom_change(maxzoom);
    break;
  }
  XClearArea(dsp, zoommenu[i].win, 0, 0, 0, 0, True);
}

zoom_enter(ev)
     XEvent *ev;
{
  menuwin_enter(zoommenu, ev);
}

zoom_leave(ev)
     XEvent *ev;
{
  if (menuwin_leave(zoommenu, ev) >= 0)
    return 1;
  return 0;
}

/* End of file */
